/** 
 * fiwalk.h
 */

#include <algorithm>
#include <cstdlib>
#include <vector>
#include <string>

#include "bloom.h"
#include "bloomset.h"

using namespace std;

/* Structure for keeping track of file segments */
class seg {
public:;
    int64_t fs_offset;		    // byte offset from start of file system
    int64_t img_offset;		    // offset from beginning of image
    int64_t file_offset;		    // logical number of bytes from beginning of file
    int64_t len;		    // number of bytes
    TSK_FS_BLOCK_FLAG_ENUM flags;   // 
};

typedef vector<class seg> seglist;	// vector of blocks
typedef vector<string> namelist_t;
extern namelist_t namelist;

extern bool opt_save;			// should we save content?
extern bool opt_magic;			// should we run libmagic?
extern bool opt_md5;			// do we need md5s?
extern bool opt_sha1;			// do we need sha1s?
extern bool opt_userguess;		// should we try to guess the user?
extern bool opt_multithreaded;		// use multiple threading
extern string save_outdir;
extern bool opt_get_fragments;

void file_info(const string &name,const string &value);
void file_info_xml(const string &name,const string &value);
void file_info(const string name, int64_t value);
void file_infot(const string name,time_t t0);
extern int sector_size;
void add_userguess(const string &path);
extern bloomset mybloomset;


extern class arff *a;
extern class xml *x;
